# ZMQ.jl

*A Julia interface to ZeroMQ*

| **Documentation**                                                         | **Coverage**                    |
|:-------------------------------------------------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![][codecov-img]][codecov-url] |

**ZMQ.jl** is a [Julia](http://julialang.org) interface to [ZeroMQ, The Intelligent Transport Layer](http://zeromq.org).

## Installation

The package can be installed with the Julia package manager.
From the Julia REPL, type `]` to enter the Pkg REPL mode and run:

```
pkg> add ZMQ
```

Or, equivalently, via the `Pkg` API:

```julia
julia> import Pkg; Pkg.add("ZMQ")
```

## Documentation

- [**STABLE**][docs-stable-url] &mdash; **documentation of the most recently tagged version.**
- [**DEVEL**][docs-dev-url] &mdash; *documentation of the in-development version.*

## Questions and Contributions

Usage questions can be posted on the [Julia Discourse forum][discourse-tag-url]
under the `zmq` tag, in the `#helpdesk` channel of the [Julia
Slack](https://julialang.org/community/), or the `#helpdesk`/`#helpdesk
(published)` stream of the [Julia Zulip](https://julialang.zulipchat.com/).

Contributions are very welcome, as are feature requests and suggestions. Please
open an [issue][issues-url] if you encounter any problems.

[discourse-tag-url]: https://discourse.julialang.org/tags/zmq

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://juliainterop.github.io/ZMQ.jl/latest

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliainterop.github.io/ZMQ.jl/stable

[codecov-img]: https://codecov.io/gh/JuliaInterop/ZMQ.jl/graph/badge.svg?token=NMxuhZepAU
[codecov-url]: https://codecov.io/gh/JuliaInterop/ZMQ.jl

[issues-url]: https://github.com/JuliaInterop/ZMQ.jl/issues

## Constants

# Context options
const IO_THREADS = lib.ZMQ_IO_THREADS
const MAX_SOCKETS = lib.ZMQ_MAX_SOCKETS
const IPV6 = lib.ZMQ_IPV6

"[PAIR](https://zeromq.org/socket-api/#pair-socket) socket."
const PAIR = lib.ZMQ_PAIR
"[PUB](https://zeromq.org/socket-api/#pub-socket) socket."
const PUB = lib.ZMQ_PUB
"[SUB](https://zeromq.org/socket-api/#sub-socket) socket."
const SUB = lib.ZMQ_SUB
"[REQ](https://zeromq.org/socket-api/#req-socket) socket."
const REQ = lib.ZMQ_REQ
"[REP](https://zeromq.org/socket-api/#rep-socket) socket."
const REP = lib.ZMQ_REP
"[DEALER](https://zeromq.org/socket-api/#dealer-socket) socket."
const DEALER = lib.ZMQ_DEALER
"[ROUTER](https://zeromq.org/socket-api/#router-socket) socket."
const ROUTER = lib.ZMQ_ROUTER
"[PULL](https://zeromq.org/socket-api/#pull-socket) socket."
const PULL = lib.ZMQ_PULL
"[PUSH](https://zeromq.org/socket-api/#push-socket) socket."
const PUSH = lib.ZMQ_PUSH
"[XPUB](https://zeromq.org/socket-api/#xpub-socket) socket."
const XPUB = lib.ZMQ_XPUB
"[XSUB](https://zeromq.org/socket-api/#xsub-socket) socket."
const XSUB = lib.ZMQ_XSUB
"""
[XREQ](https://zeromq.org/socket-api/#dealer-socket) socket.

!!! compat
    This is a deprecated alias for [ZMQ.DEALER](@ref).
"""
const XREQ = DEALER

"""
[XREP](https://zeromq.org/socket-api/#router-socket) socket.

!!! compat
    This is a deprecated alias for [ZMQ.ROUTER](@ref).
"""
const XREP = ROUTER

"""
[UPSTREAM](https://zeromq.org/socket-api/#pull-socket) socket.

!!! compat
    This is a deprecated alias for [ZMQ.PULL](@ref).
"""
const UPSTREAM = PULL

"""
[DOWNSTREAM](https://zeromq.org/socket-api/#push-socket) socket.

!!! compat
    This is a deprecated alias for [ZMQ.PUSH](@ref).
"""
const DOWNSTREAM = PUSH

#Message options
const MORE = lib.ZMQ_MORE
const SNDMORE = true

#IO Multiplexing
const POLLIN = lib.ZMQ_POLLIN
const POLLOUT = lib.ZMQ_POLLOUT
const POLLERR = lib.ZMQ_POLLERR

#Built in devices
const STREAMER = lib.ZMQ_STREAMER
const FORWARDER = lib.ZMQ_FORWARDER
const QUEUE = lib.ZMQ_QUEUE


#Send/Recv Options
const ZMQ_DONTWAIT = lib.ZMQ_DONTWAIT
const ZMQ_SNDMORE = lib.ZMQ_SNDMORE

# Utility to make it easier to define get/setproperty for a long list of options.

# build up the body of get/setproperty from a list of properties, of the form
#     if name === $prop
#         ($doit(prop))
#     elseif ...
# for getproperty(value, name) or setproperty!(value, name, x)
function propexpression(doit::Function, properties)
    ex = :(error(typeof(value), " has no field ", name))
    for prop in properties
        ex = Expr(:elseif, :(name === $(QuoteNode(prop))), doit(prop), ex)
    end
    return Expr(:if, ex.args...)
end

using Documenter, ZMQ
import Changelog

# Build the changelog
Changelog.generate(
    Changelog.Documenter(),
    joinpath(@__DIR__, "src/_changelog.md"),
    joinpath(@__DIR__, "src/changelog.md"),
    repo="JuliaInterop/ZMQ.jl"
)

makedocs(
    modules = [ZMQ],
    sitename="ZMQ.jl",
    authors = "Joel Frederico",
    pages = [
        "Home" => "index.md",
        "Manual" => Any[
            "Guide" => "man/guide.md",
            "man/examples.md",
        ],
        "Reference" => "reference.md",
        "Bindings" => "bindings.md",
        "Changelog" => "changelog.md"
    ],
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true")
)

deploydocs(
    repo = "github.com/JuliaInterop/ZMQ.jl.git",
    target = "build",
)

module lib

import ZeroMQ_jll: libzmq


"""
    zmq_errno()

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_errno.html).
"""
function zmq_errno()
    ccall((:zmq_errno, libzmq), Cint, ())
end

"""
    zmq_strerror(errnum_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_strerror.html).
"""
function zmq_strerror(errnum_)
    ccall((:zmq_strerror, libzmq), Ptr{Cchar}, (Cint,), errnum_)
end

"""
    zmq_version(major_, minor_, patch_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_version.html).
"""
function zmq_version(major_, minor_, patch_)
    ccall((:zmq_version, libzmq), Cvoid, (Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), major_, minor_, patch_)
end

"""
    zmq_ctx_new()

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_ctx_new.html).
"""
function zmq_ctx_new()
    ccall((:zmq_ctx_new, libzmq), Ptr{Cvoid}, ())
end

"""
    zmq_ctx_term(context_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_ctx_term.html).
"""
function zmq_ctx_term(context_)
    ccall((:zmq_ctx_term, libzmq), Cint, (Ptr{Cvoid},), context_)
end

"""
    zmq_ctx_shutdown(context_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_ctx_shutdown.html).
"""
function zmq_ctx_shutdown(context_)
    ccall((:zmq_ctx_shutdown, libzmq), Cint, (Ptr{Cvoid},), context_)
end

"""
    zmq_ctx_set(context_, option_, optval_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_ctx_set.html).
"""
function zmq_ctx_set(context_, option_, optval_)
    ccall((:zmq_ctx_set, libzmq), Cint, (Ptr{Cvoid}, Cint, Cint), context_, option_, optval_)
end

"""
    zmq_ctx_get(context_, option_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_ctx_get.html).
"""
function zmq_ctx_get(context_, option_)
    ccall((:zmq_ctx_get, libzmq), Cint, (Ptr{Cvoid}, Cint), context_, option_)
end

struct zmq_msg_t
    data::NTuple{64, UInt8}
end

function Base.getproperty(x::Ptr{zmq_msg_t}, f::Symbol)
    f === :_ && return Ptr{NTuple{64, Cuchar}}(x + 0)
    return getfield(x, f)
end

function Base.getproperty(x::zmq_msg_t, f::Symbol)
    r = Ref{zmq_msg_t}(x)
    ptr = Base.unsafe_convert(Ptr{zmq_msg_t}, r)
    fptr = getproperty(ptr, f)
    GC.@preserve r unsafe_load(fptr)
end

function Base.setproperty!(x::Ptr{zmq_msg_t}, f::Symbol, v)
    unsafe_store!(getproperty(x, f), v)
end

# typedef void ( zmq_free_fn ) ( void * data_ , void * hint_ )
const zmq_free_fn = Cvoid

"""
    zmq_msg_init(msg_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_init.html).
"""
function zmq_msg_init(msg_)
    ccall((:zmq_msg_init, libzmq), Cint, (Ptr{zmq_msg_t},), msg_)
end

"""
    zmq_msg_init_size(msg_, size_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_init_size.html).
"""
function zmq_msg_init_size(msg_, size_)
    ccall((:zmq_msg_init_size, libzmq), Cint, (Ptr{zmq_msg_t}, Csize_t), msg_, size_)
end

"""
    zmq_msg_init_data(msg_, data_, size_, ffn_, hint_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_init_data.html).
"""
function zmq_msg_init_data(msg_, data_, size_, ffn_, hint_)
    ccall((:zmq_msg_init_data, libzmq), Cint, (Ptr{zmq_msg_t}, Ptr{Cvoid}, Csize_t, Ptr{zmq_free_fn}, Ptr{Cvoid}), msg_, data_, size_, ffn_, hint_)
end

"""
    zmq_msg_send(msg_, s_, flags_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_send.html).
"""
function zmq_msg_send(msg_, s_, flags_)
    ccall((:zmq_msg_send, libzmq), Cint, (Ptr{zmq_msg_t}, Ptr{Cvoid}, Cint), msg_, s_, flags_)
end

"""
    zmq_msg_recv(msg_, s_, flags_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_recv.html).
"""
function zmq_msg_recv(msg_, s_, flags_)
    ccall((:zmq_msg_recv, libzmq), Cint, (Ptr{zmq_msg_t}, Ptr{Cvoid}, Cint), msg_, s_, flags_)
end

"""
    zmq_msg_close(msg_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_close.html).
"""
function zmq_msg_close(msg_)
    ccall((:zmq_msg_close, libzmq), Cint, (Ptr{zmq_msg_t},), msg_)
end

"""
    zmq_msg_move(dest_, src_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_move.html).
"""
function zmq_msg_move(dest_, src_)
    ccall((:zmq_msg_move, libzmq), Cint, (Ptr{zmq_msg_t}, Ptr{zmq_msg_t}), dest_, src_)
end

"""
    zmq_msg_copy(dest_, src_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_copy.html).
"""
function zmq_msg_copy(dest_, src_)
    ccall((:zmq_msg_copy, libzmq), Cint, (Ptr{zmq_msg_t}, Ptr{zmq_msg_t}), dest_, src_)
end

"""
    zmq_msg_data(msg_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_data.html).
"""
function zmq_msg_data(msg_)
    ccall((:zmq_msg_data, libzmq), Ptr{Cvoid}, (Ptr{zmq_msg_t},), msg_)
end

"""
    zmq_msg_size(msg_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_size.html).
"""
function zmq_msg_size(msg_)
    ccall((:zmq_msg_size, libzmq), Csize_t, (Ptr{zmq_msg_t},), msg_)
end

"""
    zmq_msg_more(msg_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_more.html).
"""
function zmq_msg_more(msg_)
    ccall((:zmq_msg_more, libzmq), Cint, (Ptr{zmq_msg_t},), msg_)
end

"""
    zmq_msg_get(msg_, property_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_get.html).
"""
function zmq_msg_get(msg_, property_)
    ccall((:zmq_msg_get, libzmq), Cint, (Ptr{zmq_msg_t}, Cint), msg_, property_)
end

"""
    zmq_msg_set(msg_, property_, optval_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_set.html).
"""
function zmq_msg_set(msg_, property_, optval_)
    ccall((:zmq_msg_set, libzmq), Cint, (Ptr{zmq_msg_t}, Cint, Cint), msg_, property_, optval_)
end

"""
    zmq_msg_gets(msg_, property_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_msg_gets.html).
"""
function zmq_msg_gets(msg_, property_)
    ccall((:zmq_msg_gets, libzmq), Ptr{Cchar}, (Ptr{zmq_msg_t}, Ptr{Cchar}), msg_, property_)
end

"""
    zmq_socket(arg1, type_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_socket.html).
"""
function zmq_socket(arg1, type_)
    ccall((:zmq_socket, libzmq), Ptr{Cvoid}, (Ptr{Cvoid}, Cint), arg1, type_)
end

"""
    zmq_close(s_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_close.html).
"""
function zmq_close(s_)
    ccall((:zmq_close, libzmq), Cint, (Ptr{Cvoid},), s_)
end

"""
    zmq_setsockopt(s_, option_, optval_, optvallen_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_setsockopt.html).
"""
function zmq_setsockopt(s_, option_, optval_, optvallen_)
    ccall((:zmq_setsockopt, libzmq), Cint, (Ptr{Cvoid}, Cint, Ptr{Cvoid}, Csize_t), s_, option_, optval_, optvallen_)
end

"""
    zmq_getsockopt(s_, option_, optval_, optvallen_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_getsockopt.html).
"""
function zmq_getsockopt(s_, option_, optval_, optvallen_)
    ccall((:zmq_getsockopt, libzmq), Cint, (Ptr{Cvoid}, Cint, Ptr{Cvoid}, Ptr{Csize_t}), s_, option_, optval_, optvallen_)
end

"""
    zmq_bind(s_, addr_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_bind.html).
"""
function zmq_bind(s_, addr_)
    ccall((:zmq_bind, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cchar}), s_, addr_)
end

"""
    zmq_connect(s_, addr_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_connect.html).
"""
function zmq_connect(s_, addr_)
    ccall((:zmq_connect, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cchar}), s_, addr_)
end

"""
    zmq_unbind(s_, addr_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_unbind.html).
"""
function zmq_unbind(s_, addr_)
    ccall((:zmq_unbind, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cchar}), s_, addr_)
end

"""
    zmq_disconnect(s_, addr_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_disconnect.html).
"""
function zmq_disconnect(s_, addr_)
    ccall((:zmq_disconnect, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cchar}), s_, addr_)
end

"""
    zmq_send(s_, buf_, len_, flags_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_send.html).
"""
function zmq_send(s_, buf_, len_, flags_)
    ccall((:zmq_send, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Cint), s_, buf_, len_, flags_)
end

"""
    zmq_send_const(s_, buf_, len_, flags_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_send_const.html).
"""
function zmq_send_const(s_, buf_, len_, flags_)
    ccall((:zmq_send_const, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Cint), s_, buf_, len_, flags_)
end

"""
    zmq_recv(s_, buf_, len_, flags_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_recv.html).
"""
function zmq_recv(s_, buf_, len_, flags_)
    ccall((:zmq_recv, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Cint), s_, buf_, len_, flags_)
end

"""
    zmq_socket_monitor(s_, addr_, events_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_socket_monitor.html).
"""
function zmq_socket_monitor(s_, addr_, events_)
    ccall((:zmq_socket_monitor, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cchar}, Cint), s_, addr_, events_)
end

const zmq_fd_t = Cint

mutable struct zmq_pollitem_t
    socket::Ptr{Cvoid}
    fd::zmq_fd_t
    events::Cshort
    revents::Cshort
end

"""
    zmq_poll(items_, nitems_, timeout_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_poll.html).
"""
function zmq_poll(items_, nitems_, timeout_)
    ccall((:zmq_poll, libzmq), Cint, (Ptr{zmq_pollitem_t}, Cint, Clong), items_, nitems_, timeout_)
end

"""
    zmq_proxy(frontend_, backend_, capture_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_proxy.html).
"""
function zmq_proxy(frontend_, backend_, capture_)
    ccall((:zmq_proxy, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), frontend_, backend_, capture_)
end

"""
    zmq_proxy_steerable(frontend_, backend_, capture_, control_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_proxy_steerable.html).
"""
function zmq_proxy_steerable(frontend_, backend_, capture_, control_)
    ccall((:zmq_proxy_steerable, libzmq), Cint, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), frontend_, backend_, capture_, control_)
end

"""
    zmq_has(capability_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_has.html).
"""
function zmq_has(capability_)
    ccall((:zmq_has, libzmq), Cint, (Ptr{Cchar},), capability_)
end

"""
    zmq_z85_encode(dest_, data_, size_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_z85_encode.html).
"""
function zmq_z85_encode(dest_, data_, size_)
    ccall((:zmq_z85_encode, libzmq), Ptr{Cchar}, (Ptr{Cchar}, Ptr{UInt8}, Csize_t), dest_, data_, size_)
end

"""
    zmq_z85_decode(dest_, string_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_z85_decode.html).
"""
function zmq_z85_decode(dest_, string_)
    ccall((:zmq_z85_decode, libzmq), Ptr{UInt8}, (Ptr{UInt8}, Ptr{Cchar}), dest_, string_)
end

"""
    zmq_curve_keypair(z85_public_key_, z85_secret_key_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_curve_keypair.html).
"""
function zmq_curve_keypair(z85_public_key_, z85_secret_key_)
    ccall((:zmq_curve_keypair, libzmq), Cint, (Ptr{Cchar}, Ptr{Cchar}), z85_public_key_, z85_secret_key_)
end

"""
    zmq_curve_public(z85_public_key_, z85_secret_key_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_curve_public.html).
"""
function zmq_curve_public(z85_public_key_, z85_secret_key_)
    ccall((:zmq_curve_public, libzmq), Cint, (Ptr{Cchar}, Ptr{Cchar}), z85_public_key_, z85_secret_key_)
end

"""
    zmq_atomic_counter_new()

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_new.html).
"""
function zmq_atomic_counter_new()
    ccall((:zmq_atomic_counter_new, libzmq), Ptr{Cvoid}, ())
end

"""
    zmq_atomic_counter_set(counter_, value_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_set.html).
"""
function zmq_atomic_counter_set(counter_, value_)
    ccall((:zmq_atomic_counter_set, libzmq), Cvoid, (Ptr{Cvoid}, Cint), counter_, value_)
end

"""
    zmq_atomic_counter_inc(counter_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_inc.html).
"""
function zmq_atomic_counter_inc(counter_)
    ccall((:zmq_atomic_counter_inc, libzmq), Cint, (Ptr{Cvoid},), counter_)
end

"""
    zmq_atomic_counter_dec(counter_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_dec.html).
"""
function zmq_atomic_counter_dec(counter_)
    ccall((:zmq_atomic_counter_dec, libzmq), Cint, (Ptr{Cvoid},), counter_)
end

"""
    zmq_atomic_counter_value(counter_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_value.html).
"""
function zmq_atomic_counter_value(counter_)
    ccall((:zmq_atomic_counter_value, libzmq), Cint, (Ptr{Cvoid},), counter_)
end

"""
    zmq_atomic_counter_destroy(counter_p_)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_atomic_counter_destroy.html).
"""
function zmq_atomic_counter_destroy(counter_p_)
    ccall((:zmq_atomic_counter_destroy, libzmq), Cvoid, (Ptr{Ptr{Cvoid}},), counter_p_)
end

# typedef void ( zmq_timer_fn ) ( int timer_id , void * arg )
const zmq_timer_fn = Cvoid

"""
    zmq_timers_new()

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_new()
    ccall((:zmq_timers_new, libzmq), Ptr{Cvoid}, ())
end

"""
    zmq_timers_destroy(timers_p)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_destroy(timers_p)
    ccall((:zmq_timers_destroy, libzmq), Cint, (Ptr{Ptr{Cvoid}},), timers_p)
end

"""
    zmq_timers_add(timers, interval, handler, arg)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_add(timers, interval, handler, arg)
    ccall((:zmq_timers_add, libzmq), Cint, (Ptr{Cvoid}, Csize_t, zmq_timer_fn, Ptr{Cvoid}), timers, interval, handler, arg)
end

"""
    zmq_timers_cancel(timers, timer_id)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_cancel(timers, timer_id)
    ccall((:zmq_timers_cancel, libzmq), Cint, (Ptr{Cvoid}, Cint), timers, timer_id)
end

"""
    zmq_timers_set_interval(timers, timer_id, interval)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_set_interval(timers, timer_id, interval)
    ccall((:zmq_timers_set_interval, libzmq), Cint, (Ptr{Cvoid}, Cint, Csize_t), timers, timer_id, interval)
end

"""
    zmq_timers_reset(timers, timer_id)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_reset(timers, timer_id)
    ccall((:zmq_timers_reset, libzmq), Cint, (Ptr{Cvoid}, Cint), timers, timer_id)
end

"""
    zmq_timers_timeout(timers)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_timeout(timers)
    ccall((:zmq_timers_timeout, libzmq), Clong, (Ptr{Cvoid},), timers)
end

"""
    zmq_timers_execute(timers)

[Upstream documentation](https://libzmq.readthedocs.io/en/latest/zmq_timers.html).
"""
function zmq_timers_execute(timers)
    ccall((:zmq_timers_execute, libzmq), Cint, (Ptr{Cvoid},), timers)
end

"""
    zmq_stopwatch_start()

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_stopwatch_start()
    ccall((:zmq_stopwatch_start, libzmq), Ptr{Cvoid}, ())
end

"""
    zmq_stopwatch_intermediate(watch_)

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_stopwatch_intermediate(watch_)
    ccall((:zmq_stopwatch_intermediate, libzmq), Culong, (Ptr{Cvoid},), watch_)
end

"""
    zmq_stopwatch_stop(watch_)

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_stopwatch_stop(watch_)
    ccall((:zmq_stopwatch_stop, libzmq), Culong, (Ptr{Cvoid},), watch_)
end

"""
    zmq_sleep(seconds_)

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_sleep(seconds_)
    ccall((:zmq_sleep, libzmq), Cvoid, (Cint,), seconds_)
end

# typedef void ( zmq_thread_fn ) ( void * )
const zmq_thread_fn = Cvoid

"""
    zmq_threadstart(func_, arg_)

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_threadstart(func_, arg_)
    ccall((:zmq_threadstart, libzmq), Ptr{Cvoid}, (Ptr{zmq_thread_fn}, Ptr{Cvoid}), func_, arg_)
end

"""
    zmq_threadclose(thread_)

This is an undocumented function, not part of the formal ZMQ API.
"""
function zmq_threadclose(thread_)
    ccall((:zmq_threadclose, libzmq), Cvoid, (Ptr{Cvoid},), thread_)
end

const ZMQ_VERSION_MAJOR = 4

const ZMQ_VERSION_MINOR = 3

const ZMQ_VERSION_PATCH = 5

# Skipping MacroDefinition: ZMQ_EXPORT __attribute__ ( ( visibility ( "default" ) ) )

const ZMQ_DEFINED_STDINT = 1

const ZMQ_HAUSNUMERO = 156384712

const EFSM = ZMQ_HAUSNUMERO + 51

const ENOCOMPATPROTO = ZMQ_HAUSNUMERO + 52

const ETERM = ZMQ_HAUSNUMERO + 53

const EMTHREAD = ZMQ_HAUSNUMERO + 54

const ZMQ_IO_THREADS = 1

const ZMQ_MAX_SOCKETS = 2

const ZMQ_SOCKET_LIMIT = 3

const ZMQ_THREAD_PRIORITY = 3

const ZMQ_THREAD_SCHED_POLICY = 4

const ZMQ_MAX_MSGSZ = 5

const ZMQ_MSG_T_SIZE = 6

const ZMQ_THREAD_AFFINITY_CPU_ADD = 7

const ZMQ_THREAD_AFFINITY_CPU_REMOVE = 8

const ZMQ_THREAD_NAME_PREFIX = 9

const ZMQ_IO_THREADS_DFLT = 1

const ZMQ_MAX_SOCKETS_DFLT = 1023

const ZMQ_THREAD_PRIORITY_DFLT = -1

const ZMQ_THREAD_SCHED_POLICY_DFLT = -1

const ZMQ_PAIR = 0

const ZMQ_PUB = 1

const ZMQ_SUB = 2

const ZMQ_REQ = 3

const ZMQ_REP = 4

const ZMQ_DEALER = 5

const ZMQ_ROUTER = 6

const ZMQ_PULL = 7

const ZMQ_PUSH = 8

const ZMQ_XPUB = 9

const ZMQ_XSUB = 10

const ZMQ_STREAM = 11

const ZMQ_XREQ = ZMQ_DEALER

const ZMQ_XREP = ZMQ_ROUTER

const ZMQ_AFFINITY = 4

const ZMQ_ROUTING_ID = 5

const ZMQ_SUBSCRIBE = 6

const ZMQ_UNSUBSCRIBE = 7

const ZMQ_RATE = 8

const ZMQ_RECOVERY_IVL = 9

const ZMQ_SNDBUF = 11

const ZMQ_RCVBUF = 12

const ZMQ_RCVMORE = 13

const ZMQ_FD = 14

const ZMQ_EVENTS = 15

const ZMQ_TYPE = 16

const ZMQ_LINGER = 17

const ZMQ_RECONNECT_IVL = 18

const ZMQ_BACKLOG = 19

const ZMQ_RECONNECT_IVL_MAX = 21

const ZMQ_MAXMSGSIZE = 22

const ZMQ_SNDHWM = 23

const ZMQ_RCVHWM = 24

const ZMQ_MULTICAST_HOPS = 25

const ZMQ_RCVTIMEO = 27

const ZMQ_SNDTIMEO = 28

const ZMQ_LAST_ENDPOINT = 32

const ZMQ_ROUTER_MANDATORY = 33

const ZMQ_TCP_KEEPALIVE = 34

const ZMQ_TCP_KEEPALIVE_CNT = 35

const ZMQ_TCP_KEEPALIVE_IDLE = 36

const ZMQ_TCP_KEEPALIVE_INTVL = 37

const ZMQ_IMMEDIATE = 39

const ZMQ_XPUB_VERBOSE = 40

const ZMQ_ROUTER_RAW = 41

const ZMQ_IPV6 = 42

const ZMQ_MECHANISM = 43

const ZMQ_PLAIN_SERVER = 44

const ZMQ_PLAIN_USERNAME = 45

const ZMQ_PLAIN_PASSWORD = 46

const ZMQ_CURVE_SERVER = 47

const ZMQ_CURVE_PUBLICKEY = 48

const ZMQ_CURVE_SECRETKEY = 49

const ZMQ_CURVE_SERVERKEY = 50

const ZMQ_PROBE_ROUTER = 51

const ZMQ_REQ_CORRELATE = 52

const ZMQ_REQ_RELAXED = 53

const ZMQ_CONFLATE = 54

const ZMQ_ZAP_DOMAIN = 55

const ZMQ_ROUTER_HANDOVER = 56

const ZMQ_TOS = 57

const ZMQ_CONNECT_ROUTING_ID = 61

const ZMQ_GSSAPI_SERVER = 62

const ZMQ_GSSAPI_PRINCIPAL = 63

const ZMQ_GSSAPI_SERVICE_PRINCIPAL = 64

const ZMQ_GSSAPI_PLAINTEXT = 65

const ZMQ_HANDSHAKE_IVL = 66

const ZMQ_SOCKS_PROXY = 68

const ZMQ_XPUB_NODROP = 69

const ZMQ_BLOCKY = 70

const ZMQ_XPUB_MANUAL = 71

const ZMQ_XPUB_WELCOME_MSG = 72

const ZMQ_STREAM_NOTIFY = 73

const ZMQ_INVERT_MATCHING = 74

const ZMQ_HEARTBEAT_IVL = 75

const ZMQ_HEARTBEAT_TTL = 76

const ZMQ_HEARTBEAT_TIMEOUT = 77

const ZMQ_XPUB_VERBOSER = 78

const ZMQ_CONNECT_TIMEOUT = 79

const ZMQ_TCP_MAXRT = 80

const ZMQ_THREAD_SAFE = 81

const ZMQ_MULTICAST_MAXTPDU = 84

const ZMQ_VMCI_BUFFER_SIZE = 85

const ZMQ_VMCI_BUFFER_MIN_SIZE = 86

const ZMQ_VMCI_BUFFER_MAX_SIZE = 87

const ZMQ_VMCI_CONNECT_TIMEOUT = 88

const ZMQ_USE_FD = 89

const ZMQ_GSSAPI_PRINCIPAL_NAMETYPE = 90

const ZMQ_GSSAPI_SERVICE_PRINCIPAL_NAMETYPE = 91

const ZMQ_BINDTODEVICE = 92

const ZMQ_MORE = 1

const ZMQ_SHARED = 3

const ZMQ_DONTWAIT = 1

const ZMQ_SNDMORE = 2

const ZMQ_NULL = 0

const ZMQ_PLAIN = 1

const ZMQ_CURVE = 2

const ZMQ_GSSAPI = 3

const ZMQ_GROUP_MAX_LENGTH = 255

const ZMQ_IDENTITY = ZMQ_ROUTING_ID

const ZMQ_CONNECT_RID = ZMQ_CONNECT_ROUTING_ID

const ZMQ_TCP_ACCEPT_FILTER = 38

const ZMQ_IPC_FILTER_PID = 58

const ZMQ_IPC_FILTER_UID = 59

const ZMQ_IPC_FILTER_GID = 60

const ZMQ_IPV4ONLY = 31

const ZMQ_DELAY_ATTACH_ON_CONNECT = ZMQ_IMMEDIATE

const ZMQ_NOBLOCK = ZMQ_DONTWAIT

const ZMQ_FAIL_UNROUTABLE = ZMQ_ROUTER_MANDATORY

const ZMQ_ROUTER_BEHAVIOR = ZMQ_ROUTER_MANDATORY

const ZMQ_SRCFD = 2

const ZMQ_GSSAPI_NT_HOSTBASED = 0

const ZMQ_GSSAPI_NT_USER_NAME = 1

const ZMQ_GSSAPI_NT_KRB5_PRINCIPAL = 2

const ZMQ_EVENT_CONNECTED = 0x0001

const ZMQ_EVENT_CONNECT_DELAYED = 0x0002

const ZMQ_EVENT_CONNECT_RETRIED = 0x0004

const ZMQ_EVENT_LISTENING = 0x0008

const ZMQ_EVENT_BIND_FAILED = 0x0010

const ZMQ_EVENT_ACCEPTED = 0x0020

const ZMQ_EVENT_ACCEPT_FAILED = 0x0040

const ZMQ_EVENT_CLOSED = 0x0080

const ZMQ_EVENT_CLOSE_FAILED = 0x0100

const ZMQ_EVENT_DISCONNECTED = 0x0200

const ZMQ_EVENT_MONITOR_STOPPED = 0x0400

const ZMQ_EVENT_ALL = 0xffff

const ZMQ_EVENT_HANDSHAKE_FAILED_NO_DETAIL = 0x0800

const ZMQ_EVENT_HANDSHAKE_SUCCEEDED = 0x1000

const ZMQ_EVENT_HANDSHAKE_FAILED_PROTOCOL = 0x2000

const ZMQ_EVENT_HANDSHAKE_FAILED_AUTH = 0x4000

const ZMQ_PROTOCOL_ERROR_ZMTP_UNSPECIFIED = 0x10000000

const ZMQ_PROTOCOL_ERROR_ZMTP_UNEXPECTED_COMMAND = 0x10000001

const ZMQ_PROTOCOL_ERROR_ZMTP_INVALID_SEQUENCE = 0x10000002

const ZMQ_PROTOCOL_ERROR_ZMTP_KEY_EXCHANGE = 0x10000003

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_UNSPECIFIED = 0x10000011

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_MESSAGE = 0x10000012

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_HELLO = 0x10000013

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_INITIATE = 0x10000014

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_ERROR = 0x10000015

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_READY = 0x10000016

const ZMQ_PROTOCOL_ERROR_ZMTP_MALFORMED_COMMAND_WELCOME = 0x10000017

const ZMQ_PROTOCOL_ERROR_ZMTP_INVALID_METADATA = 0x10000018

const ZMQ_PROTOCOL_ERROR_ZMTP_CRYPTOGRAPHIC = 0x11000001

const ZMQ_PROTOCOL_ERROR_ZMTP_MECHANISM_MISMATCH = 0x11000002

const ZMQ_PROTOCOL_ERROR_ZAP_UNSPECIFIED = 0x20000000

const ZMQ_PROTOCOL_ERROR_ZAP_MALFORMED_REPLY = 0x20000001

const ZMQ_PROTOCOL_ERROR_ZAP_BAD_REQUEST_ID = 0x20000002

const ZMQ_PROTOCOL_ERROR_ZAP_BAD_VERSION = 0x20000003

const ZMQ_PROTOCOL_ERROR_ZAP_INVALID_STATUS_CODE = 0x20000004

const ZMQ_PROTOCOL_ERROR_ZAP_INVALID_METADATA = 0x20000005

const ZMQ_PROTOCOL_ERROR_WS_UNSPECIFIED = 0x30000000

const ZMQ_POLLIN = 1

const ZMQ_POLLOUT = 2

const ZMQ_POLLERR = 4

const ZMQ_POLLPRI = 8

const ZMQ_POLLITEMS_DFLT = 16

const ZMQ_HAS_CAPABILITIES = 1

const ZMQ_STREAMER = 1

const ZMQ_FORWARDER = 2

const ZMQ_QUEUE = 3

end # module

## Send/receive messages.

############################################################################

function _send(socket::Socket, zmsg, more::Bool=false)
    while true
        if -1 == lib.zmq_msg_send(zmsg, socket, (ZMQ_SNDMORE*more) | ZMQ_DONTWAIT)
            lib.zmq_errno() == EAGAIN || throw(StateError(jl_zmq_error_str()))
            while (socket.events & POLLOUT) == 0
                wait(socket)
            end
        else
            notify_is_expensive = !isempty(getfield(socket,:pollfd).watcher.notify.waitq)
            if notify_is_expensive
                socket.events != 0 && notify(socket)
            end
            break
        end
    end
end

# By default, we send using _Message objects, which are optimized for
# small messages and copy the data.    If the caller wants zero-copy communications,
# then should explicitly create a Message() object, a more heavyweight object
# that allows zero-copy access.

"""
    send(socket::Socket, data; more=false)

Send `data` over `socket`.  A `more=true` keyword argument can be passed
to indicate that `data` is a portion of a larger multipart message.
`data` can be any `isbits` type, a `Vector` of `isbits` elements, a
`String`, or a [`Message`](@ref) object to perform zero-copy sends
of large arrays.
"""
function Sockets.send(socket::Socket, data; more::Bool=false)
    zmsg = create_MessageRef(data)
    try
        _send(socket, zmsg, more)
    finally
        close(zmsg)
    end
end

"""
    send(socket::Socket, zmsg::Message; more::Bool=false)

Zero-copy version of [`Sockets.send(socket, data)`](@ref) using a user-allocated
[`Message`](@ref).
"""
Sockets.send(socket::Socket, zmsg::Message; more::Bool=false) = _send(socket, zmsg, more)

import Sockets: send
@deprecate send(socket::Socket, data, more::Bool) send(socket, data; more=more)

function Sockets.send(f::Function, socket::Socket; more::Bool=false)
    io = IOBuffer()
    f(io)
    send(socket, take!(io); more=more)
end

"""
    send_multipart(socket::Socket, parts)

Send a multipart message composed of the elements in `parts`. `parts` may be any
object that supports `getindex()`, `eachindex()`, and `lastindex()`.
"""
function send_multipart(socket::Socket, parts)
    for i in eachindex(parts)
        is_last = i == lastindex(parts)
        send(socket, parts[i]; more=!is_last)
    end
end

############################################################################

function _recv!(socket::Socket, zmsg)
    while true
        if -1 == lib.zmq_msg_recv(zmsg, socket, ZMQ_DONTWAIT)
            lib.zmq_errno() == EAGAIN || throw(StateError(jl_zmq_error_str()))
            while socket.events & POLLIN== 0
                # If there is no receive timeout, just wait on the socket
                if socket.rcvtimeo == -1
                    wait(socket)
                else
                    # Otherwise, implement a receive timeout for the wait. We
                    # can't rely on ZMQ's native blocking behaviour because that
                    # doesn't play nicely with Julia's tasks so instead we use
                    # poll_fd() with a timeout. Note that we bypass the Socket's
                    # own FDWatcher and pass the native ZMQ socket to poll_fd().
                    timeout_secs = socket.rcvtimeo / 1000
                    ret = poll_fd(fd(socket), timeout_secs; readable=true, writable=false)
                    if ret.timedout
                        throw(TimeoutError(repr(socket), timeout_secs))
                    end
                end
            end
        else
            notify_is_expensive = !isempty(getfield(socket,:pollfd).watcher.notify.waitq)
            if notify_is_expensive
                socket.events != 0 && notify(socket)
            end
            break
        end
    end
    return zmsg
end

"""
    recv(socket::Socket)

Return a `Message` object representing a message received from a ZMQ `Socket`
(without making a copy of the message data).

If [`rcvtimeo`](https://libzmq.readthedocs.io/en/latest/zmq_setsockopt.html) is
set then a [`TimeoutError`](@ref) will be thrown upon timeout. Note that because
of the integration with Julia's event loop there is some overhead to using
timeouts, on the order of ~10μs. All other `recv*()` methods also respect
`rcvtimeo`.
"""
Sockets.recv(socket::Socket) = _recv!(socket, Message())

"""
    recv(socket::Socket, ::Type{T})

Receive a message of type `T` (typically a `String`, `Vector{UInt8}`, or
[`isbits`](https://docs.julialang.org/en/v1/base/base/#Base.isbits) type)
from a ZMQ [`Socket`](@ref).  (Makes a copy of the message data; you can alternatively
use [`recv(socket)`](@ref) to work with zero-copy bytearray-like representation for
large messages.)

"""
function Sockets.recv(socket::Socket, ::Type{T}) where {T}
    zmsg = msg_init()
    try
        _recv!(socket, zmsg)
        return unsafe_copy(T, zmsg)
    finally
        close(zmsg)
    end
end

# Specialization so that recv(::Socket, ::Message) works
Sockets.recv(socket::Socket, ::Type{Message}) = recv(socket)

"""
    recv_multipart(socket::Socket, ::Type{T}) -> Vector{T}

Receive a multipart message of a specific type `T`. This behaves in the same way
as [`recv(::Socket, ::Type)`](@ref).
"""
function recv_multipart(socket::Socket, ::Type{T}) where {T}
    parts = T[recv(socket, T)]
    while socket.rcvmore
        push!(parts, recv(socket, T))
    end

    return parts
end

"""
    recv_multipart(socket::Socket) -> Vector{Message}

Receive a multipart message as a sequence of zero-copy [`Message`](@ref)'s. See
[`recv(::Socket)`](@ref).
"""
recv_multipart(socket::Socket) = recv_multipart(socket, Message)

## Contexts ##

# the low-level context constructor
function _ctx_new()
    p = lib.zmq_ctx_new()
    if p == C_NULL
        throw(StateError(jl_zmq_error_str()))
    end
    return p
end

mutable struct Context
    data::Ptr{Cvoid}

    # need to keep a list of weakrefs to sockets for this Context in order to
    # close them before finalizing (otherwise zmq_ctx_term will hang)
    sockets::Vector{WeakRef}

    function Context()
        zctx = new(_ctx_new(), WeakRef[])
        finalizer(close, zctx)
        return zctx
    end
    function Context(::UndefInitializer)
        zctx = new(C_NULL, WeakRef[])
        finalizer(close, zctx)
        return zctx
    end
end

function Context(f::Function, args...)
    ctx = Context(args...)
    try
        f(ctx)
    finally
        close(ctx)
    end
end

function Base.show(io::IO, ctx::Context)
    if isopen(ctx)
        print(io, Context, "($(getfield(ctx, :sockets)))")
    else
        print(io, Context, "() (closed)")
    end
end

Base.unsafe_convert(::Type{Ptr{Cvoid}}, c::Context) = getfield(c, :data)

# define a global context that is initialized lazily
# and is used by default in Socket constructors, to
# save 99% of users from the low-level need to set up
# a context
const _context = Context(undef)

"""
    context()

Return the default ZMQ context (of type `Context`), initializing
it if this has not been done already.  (This context is automatically
closed when Julia exits.)
"""
function context()
    if !isopen(_context)
        setfield!(_context, :data, _ctx_new())
    end
    return _context
end

@deprecate Context(n::Integer) Context()

Base.isopen(ctx::Context) = getfield(ctx, :data) != C_NULL
function Base.close(ctx::Context)
    if isopen(ctx) # don't close twice!
        for w in getfield(ctx, :sockets)
            s = w.value
            if s isa Socket && isopen(s)
                s.linger = 0 # allow socket to shut down immediately
                close(s)
            end
        end
        empty!(getfield(ctx, :sockets))
        rc = lib.zmq_ctx_term(ctx)
        setfield!(ctx, :data, C_NULL)
        if rc != 0
            throw(StateError(jl_zmq_error_str()))
        end
    end
end
@deprecate term(ctx::Context) close(ctx)

function _get(ctx::Context, option::Integer)
    val = lib.zmq_ctx_get(ctx, option)
    if val < 0
        throw(StateError(jl_zmq_error_str()))
    end
    return val
end
function _set(ctx::Context, option::Integer, value::Integer)
    rc = lib.zmq_ctx_set(ctx, option, value)
    if rc != 0
        throw(StateError(jl_zmq_error_str()))
    end
end

const ctxopts = (:io_threads, :max_sockets, :ipv6)
Base.propertynames(::Context) = ctxopts
@eval function Base.getproperty(value::Context, name::Symbol)
    $(propexpression(ctxopts) do p
        :(_get(value, $(Symbol(uppercase(String(p))))))
    end)
end
@eval function Base.setproperty!(value::Context, name::Symbol, x::Integer)
    $(propexpression(ctxopts) do p
        :(_set(value, $(Symbol(uppercase(String(p)))), x))
    end)
    return x
end

function Base.get(ctx::Context, option::Integer)
    Base.depwarn("get(ctx, option) is deprecated; use ctx.option instead", :get)
    return _get(ctx, option)
end
function set(ctx::Context, option::Integer, value::Integer)
    Base.depwarn("set(ctx, option, val) is deprecated; use ctx.option = val instead", :set)
    return _set(ctx, option, value)
end

import ZeroMQ_jll: libzmq
import .lib: zmq_free_fn

function lib.zmq_msg_init(msg_::Message)
    ccall((:zmq_msg_init, libzmq), Cint, (Ref{Message},), msg_)
end

function lib.zmq_msg_init_size(msg_::Message, size_)
    ccall((:zmq_msg_init_size, libzmq), Cint, (Ref{Message}, Csize_t), msg_, size_)
end

function lib.zmq_msg_init_data(msg_::Message, data_, size_, ffn_, hint_)
    ccall((:zmq_msg_init_data, libzmq), Cint, (Ref{Message}, Ptr{Cvoid}, Csize_t, Ptr{zmq_free_fn}, Ptr{Cvoid}), msg_, data_, size_, ffn_, hint_)
end

function lib.zmq_msg_send(msg_::Message, s_, flags_)
    ccall((:zmq_msg_send, libzmq), Cint, (Ref{Message}, Ptr{Cvoid}, Cint), msg_, s_, flags_)
end

function lib.zmq_msg_recv(msg_::Message, s_, flags_)
    ccall((:zmq_msg_recv, libzmq), Cint, (Ref{Message}, Ptr{Cvoid}, Cint), msg_, s_, flags_)
end

function lib.zmq_msg_close(msg_::Message)
    ccall((:zmq_msg_close, libzmq), Cint, (Ref{Message},), msg_)
end

function lib.zmq_msg_move(dest_::Message, src_)
    ccall((:zmq_msg_move, libzmq), Cint, (Ref{Message}, Ref{Message}), dest_, src_)
end

function lib.zmq_msg_copy(dest_::Message, src_)
    ccall((:zmq_msg_copy, libzmq), Cint, (Ref{Message}, Ref{Message}), dest_, src_)
end

function lib.zmq_msg_data(msg_::Message)
    ccall((:zmq_msg_data, libzmq), Ptr{Cvoid}, (Ref{Message},), msg_)
end

function lib.zmq_msg_size(msg_::Message)
    ccall((:zmq_msg_size, libzmq), Csize_t, (Ref{Message},), msg_)
end

function lib.zmq_msg_more(msg_::Message)
    ccall((:zmq_msg_more, libzmq), Cint, (Ref{Message},), msg_)
end

function lib.zmq_msg_get(msg_::Message, property_)
    ccall((:zmq_msg_get, libzmq), Cint, (Ref{Message}, Cint), msg_, property_)
end

function lib.zmq_msg_set(msg_::Message, property_, optval_)
    ccall((:zmq_msg_set, libzmq), Cint, (Ref{Message}, Cint, Cint), msg_, property_, optval_)
end

function lib.zmq_msg_gets(msg_::Message, property_)
    ccall((:zmq_msg_gets, libzmq), Ptr{Cchar}, (Ref{Message}, Ptr{Cchar}), msg_, property_)
end

## Low-level _Message type for sending/receiving small ZMQ messages directly, without the complications
## and overhead of the Message object for sharing buffers between Julia and libzmq.

# Low-level message type, matching the declaration of
# zmq_msg_t in the header: char _[64];
const _Message = lib.zmq_msg_t

const _MessageRef = Base.RefValue{_Message}

function msg_init()
    zmsg = Ref{_Message}()
    rc = lib.zmq_msg_init(zmsg)
    rc != 0 && throw(StateError(jl_zmq_error_str()))
    return zmsg
end

function msg_init(nbytes::Int)
    zmsg = Ref{_Message}()
    rc = lib.zmq_msg_init_size(zmsg, nbytes % Csize_t)
    rc != 0 && throw(StateError(jl_zmq_error_str()))
    return zmsg
end

# note: no finalizer for _Message, so we need to call close manually!
function Base.close(zmsg::_MessageRef)
    rc = lib.zmq_msg_close(zmsg)
    rc != 0 && throw(StateError(jl_zmq_error_str()))
    return nothing
end

Base.length(zmsg::Base.RefValue{_Message}) = lib.zmq_msg_size(zmsg) % Int
Base.unsafe_convert(::Type{Ptr{UInt8}}, zmsg::_MessageRef) = Ptr{UInt8}(lib.zmq_msg_data(zmsg))

# isbits data, vectors thereof, and strings can be converted to/from _Message

function create_MessageRef(x::T) where {T}
    isbitstype(T) || throw(MethodError(_MessageRef, (x,)))
    n = sizeof(x)
    zmsg = msg_init(n)
    @preserve zmsg unsafe_store!(Ptr{T}(Base.unsafe_convert(Ptr{UInt8}, zmsg)), x)
    return zmsg
end

function create_MessageRef(x::Vector{T}) where {T}
    isbitstype(T) || throw(MethodError(_MessageRef, (x,)))
    n = sizeof(x)
    zmsg = msg_init(n)
    ccall(:memcpy, Ptr{Cvoid}, (Ptr{UInt8}, Ptr{T}, Csize_t), zmsg, x, n)
    return zmsg
end

function create_MessageRef(x::String)
    n = sizeof(x)
    zmsg = msg_init(n)
    ccall(:memcpy, Ptr{Cvoid}, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), zmsg, x, n)
    return zmsg
end

function unsafe_copy(::Type{Vector{T}}, zmsg::_MessageRef) where {T}
    isbitstype(T) || throw(MethodError(unsafe_copy, (T, zmsg,)))
    n = length(zmsg)
    len, remainder = divrem(n, sizeof(T))
    iszero(remainder) || error("message length $n not a multiple of sizeof($T)")
    a = Array{T}(undef, len)
    ccall(:memcpy, Ptr{Cvoid}, (Ptr{T}, Ptr{UInt8}, Csize_t), a, zmsg, n)
    return a
end

function unsafe_copy(::Type{T}, zmsg::_MessageRef) where {T}
    isbitstype(T) || throw(MethodError(unsafe_copy, (T, zmsg,)))
    n = length(zmsg)
    n == sizeof(T) || error("message length $n ≠ sizeof($T)")
    return @preserve zmsg unsafe_load(Ptr{T}(Base.unsafe_convert(Ptr{UInt8}, zmsg)))
end

function unsafe_copy(::Type{String}, zmsg::_MessageRef)
    n = length(zmsg)
    return @preserve zmsg unsafe_string(Base.unsafe_convert(Ptr{UInt8}, zmsg), n)
end

unsafe_copy(::Type{IOBuffer}, zmsg::_MessageRef) = IOBuffer(unsafe_copy(Vector{UInt8}, zmsg))

# Support for ZeroMQ, a network and interprocess communication library

module ZMQ

using Base.Libc: EAGAIN
using FileWatching: UV_READABLE, uv_pollcb, FDWatcher, poll_fd
using Printf: @sprintf
import Sockets
using Sockets: connect, bind, send, recv
import Base.GC: @preserve

export
    #Types
    StateError,Context,Socket,Message,
    #functions
    set, subscribe, unsubscribe,
    #Constants
    IO_THREADS,MAX_SOCKETS,PAIR,PUB,SUB,REQ,REP,ROUTER,DEALER,PULL,PUSH,XPUB,XSUB,XREQ,XREP,UPSTREAM,DOWNSTREAM,MORE,POLLIN,POLLOUT,POLLERR,STREAMER,FORWARDER,QUEUE,SNDMORE,
    #Sockets
    connect, bind, send, recv

include("bindings.jl")
include("constants.jl")
include("optutil.jl")
include("error.jl")
include("context.jl")
include("socket.jl")
include("sockopts.jl")
include("message.jl")
include("msg_bindings.jl")
include("comm.jl")

"""
    lib_version()

Get the libzmq version number.
"""
function lib_version()
    major = Ref{Cint}()
    minor = Ref{Cint}()
    patch = Ref{Cint}()
    lib.zmq_version(major, minor, patch)
    return VersionNumber(major[], minor[], patch[])
end

const version = lib_version()

function __init__()
    if lib_version() < v"3"
        error("ZMQ version $version < 3 is not supported")
    end
    atexit() do
        close(_context)
    end
end

import PrecompileTools: @compile_workload
@compile_workload begin
    __init__()
    # The ZMQ scoping below isn't necessary, but it makes it easier to copy/paste
    # the workload to test impact.
    s=Socket(PUB)
    ZMQ.close(s)

    s1=Socket(REP)
    s1.sndhwm = 1000
    s1.linger = 1
    s1.routing_id = "abcd"

    s2=Socket(REQ)

    # Note that ZMQ < 4.3.5 can only bind to IP address or network interface, not hostname
    ZMQ.bind(s1, "tcp://127.0.0.1:*")
    # Strip the trailing null-terminator
    last_endpoint = s1.last_endpoint[1:end - 1]
    # Parse the port from the endpoint
    port = parse(Int, split(last_endpoint, ":")[end])
    ZMQ.connect(s2, "tcp://127.0.0.1:$(port)")

    msg = Message("test request")

    ZMQ.send(s2, msg)
    unsafe_string(ZMQ.recv(s1))
    ZMQ.send(s1, Message("test response"))
    unsafe_string(ZMQ.recv(s2))
    ZMQ.close(s1)
    ZMQ.close(s2)

    # Precompile methods that are likely to be called when an exception is
    # thrown.
    repr(TimeoutError(repr(s1), 0.5))
    repr(StateError("foo"))

    # Using the library like this workload will initialize ZMQ._context, which
    # contains a pointer. This doesn't seem to play well with serialization on
    # Julia 1.6 with PackageCompiler so we explicitly close it to reset the
    # pointer.
    # See: https://github.com/JuliaLang/julia/issues/46214
    close(ZMQ._context)
end

end

"""
A ZMQ socket.
"""
mutable struct Socket
    data::Ptr{Cvoid}
    context::Context
    pollfd::FDWatcher

    @doc """
        Socket(ctx::Context, typ::Integer)

    Create a socket in a given context.
    """
    function Socket(ctx::Context, typ::Integer)
        p = lib.zmq_socket(ctx, typ)
        if p == C_NULL
            throw(StateError(jl_zmq_error_str()))
        end
        socket = new(p, ctx)
        setfield!(socket, :pollfd, FDWatcher(fd(socket), #=readable=#true, #=writable=#false))
        finalizer(close, socket)
        push!(getfield(ctx, :sockets), WeakRef(socket))
        return socket
    end

    @doc """
        Socket(typ::Integer)

    Create a socket of a certain type.
    """
    Socket(typ::Integer) = Socket(context(), typ)
end

"""
    Socket(f::Function, args...)

Do-block constructor.
"""
function Socket(f::Function, args...)
    socket = Socket(args...)
    try
        f(socket)
    finally
        close(socket)
    end
end

const _socket_type_names = Dict(
    lib.ZMQ_PAIR => "PAIR",
    lib.ZMQ_PUB => "PUB",
    lib.ZMQ_SUB => "SUB",
    lib.ZMQ_REQ => "REQ",
    lib.ZMQ_REP => "REP",
    lib.ZMQ_DEALER => "DEALER",
    lib.ZMQ_ROUTER => "ROUTER",
    lib.ZMQ_PULL => "PULL",
    lib.ZMQ_PUSH => "PUSH",
    lib.ZMQ_XPUB => "XPUB",
    lib.ZMQ_XSUB => "XSUB"
)

function Base.show(io::IO, socket::Socket)
    if isopen(socket)
        type_name = _socket_type_names[socket.type]
        last_endpoint = socket.last_endpoint == "\0" ? "" : ", $(socket.last_endpoint[1:end-1])"
        print(io, Socket, "($(type_name)$(last_endpoint))")
    else
        print(io, Socket, "() (closed)")
    end
end

Base.unsafe_convert(::Type{Ptr{Cvoid}}, s::Socket) = getfield(s, :data)

"""
    Base.isopen(socket::Socket)
"""
Base.isopen(socket::Socket) = getfield(socket, :data) != C_NULL

"""
    Base.close(socket::Socket)
"""
function Base.close(socket::Socket)
    if isopen(socket)
        close(getfield(socket, :pollfd))
        rc = lib.zmq_close(socket)
        setfield!(socket, :data, C_NULL)
        if rc != 0
            throw(StateError(jl_zmq_error_str()))
        end
    end
end

# Raw FD access
if Sys.isunix()
    Base.fd(socket::Socket) = RawFD(socket.fd)
end
if Sys.iswindows()
    using Base.Libc: WindowsRawSocket
    Base.fd(socket::Socket) = WindowsRawSocket(convert(Ptr{Cvoid}, socket.fd))
end

Base.wait(socket::Socket) = wait(getfield(socket, :pollfd))
Base.notify(socket::Socket) = @preserve socket uv_pollcb(getfield(socket, :pollfd).watcher.handle, Int32(0), Int32(UV_READABLE))

"""
    Sockets.bind(socket::Socket, endpoint::AbstractString)

Bind the socket to an endpoint. Note that the endpoint must be formatted as
described
[here](http://api.zeromq.org/4-3:zmq-bind). e.g. `tcp://127.0.0.1:42000`.
"""
function Sockets.bind(socket::Socket, endpoint::AbstractString)
    rc = lib.zmq_bind(socket, endpoint)
    if rc != 0
        throw(StateError(jl_zmq_error_str()))
    end
end

"""
    Sockets.connect(socket::Socket, endpoint::AbstractString)

Connect the socket to an endpoint.
"""
function Sockets.connect(socket::Socket, endpoint::AbstractString)
    rc = lib.zmq_connect(socket, endpoint)
    if rc != 0
        throw(StateError(jl_zmq_error_str()))
    end
end

import Clang
import Clang.Generators: FunctionProto
import ZeroMQ_jll
import MacroTools: @capture, postwalk, prettify


# Helper function to look through all the generated bindings and create new
# zmq_msg_* methods for the Message type. We need to create these overloads
# because the Message type relies on _Message (i.e. lib.zmq_msg_t) under the
# hood, and _Message is an immutable type so it doesn't have a stable address,
# and so cannot safely be passed to a ccall.
#
# We get around this for _Message by always using a Ref{_Message}, but Message
# is a mutable struct with a _Message as its first field. It's safe to pass a
# pointer to a Message to libzmq because the address of the Message is the same
# as its first field, the _Message. But to do that we need to create methods to
# ccall libzmq with the Message type instead of lib.zmq_msg_t (_Message).
function get_msg_methods(ctx, module_name)
    methods = Expr[]

    for node in ctx.dag.nodes
        for i in eachindex(node.exprs)
            expr = node.exprs[i]

            # Check if this is a function
            if @capture(expr, function name_(arg1_, args__) body_ end)
                # Check if it's a zmq_msg_* function
                if startswith(string(name), "zmq_msg_")
                    # Replace occurrences of `arg::Ptr{zmq_msg_t}` with
                    # `arg::Ref{Message}`.
                    new_body = postwalk(body) do x
                        if @capture(x, Ptr{T_}) && T == :(zmq_msg_t)
                            :(Ref{Message})
                        else
                            x
                        end
                    end

                    # Create the new method
                    new_method = quote
                        function $module_name.$name($arg1::Message, $(args...))
                            $new_body
                        end
                    end

                    push!(methods, prettify(new_method))
                end
            end
        end
    end

    return methods
end

# See:
# https://github.com/zeromq/libzmq/blob/c2fae81460d9d39a896da7b3f72484d23a172fa7/include/zmq.h#L582-L611
const undocumented_functions = [:zmq_stopwatch_start,
                                :zmq_stopwatch_intermediate,
                                :zmq_stopwatch_stop,
                                :zmq_sleep,
                                :zmq_threadstart,
                                :zmq_threadclose]
function get_docs(node, doc)
    # Only add docstrings for functions
    if !(node.type isa FunctionProto)
        return doc
    end

    url_prefix = "https://libzmq.readthedocs.io/en/latest"

    # The timer functions are all documented on a single page
    if startswith(string(node.id), "zmq_timers")
        return ["[Upstream documentation]($(url_prefix)/zmq_timers.html)."]
    elseif node.id in undocumented_functions
        return ["This is an undocumented function, not part of the formal ZMQ API."]
    else
        # For all the others, generate the URL from the function name
        return ["[Upstream documentation]($(url_prefix)/$(node.id).html)."]
    end
end

cd(@__DIR__) do
    # Set the options
    options = Clang.load_options(joinpath(@__DIR__, "generator.toml"))
    options["general"]["callback_documentation"] = get_docs
    header = joinpath(ZeroMQ_jll.artifact_dir, "include", "zmq.h")
    args = Clang.get_default_args()

    # Generate the generic bindings
    ctx = Clang.create_context([header], args, options)
    Clang.build!(ctx)

    # Generate the Message methods we need
    module_name = Symbol(options["general"]["module_name"])
    msg_methods = get_msg_methods(ctx, module_name)
    output_file = joinpath(@__DIR__, "../src/msg_bindings.jl")
    open(output_file; write=true) do io
        # Import symbols required by the bindings
        write(io, "import ZeroMQ_jll: libzmq\n")
        write(io, "import .lib: zmq_free_fn\n\n")

        for expr in msg_methods
            write(io, string(expr), "\n\n")
        end
    end
end

include("_message.jl")

# in order to support zero-copy messages that share data with Julia
# arrays, we need to hold a reference to the Julia object in a dictionary
# until zeromq is done with the data, to prevent it from being garbage
# collected.  The gc_protect dictionary is keyed by a uv_async_t* pointer,
# used in uv_async_send to tell Julia to when zeromq is done with the data.
const gc_protect = Dict{Ptr{Cvoid},Any}()

# callback argument for AsyncCondition
gc_protect_cb(work) = (pop!(gc_protect, work.handle, nothing); Base.close(work))

function gc_protect_handle(obj::Any)
    work = Base.AsyncCondition(gc_protect_cb)
    gc_protect[work.handle] = (work,obj)
    work.handle
end

# Thread-safe zeromq callback when data is freed, passed to zmq_msg_init_data.
# The hint parameter will be a uv_async_t* pointer.
function gc_free_fn(data::Ptr{Cvoid}, hint::Ptr{Cvoid})
    ccall(:uv_async_send,Cint,(Ptr{Cvoid},),hint)
end

"""
    mutable struct Message <: AbstractArray{UInt8, 1}

High-level `Message` object for sending/receiving ZMQ messages in shared
buffers. As an `AbstractArray`, it supports common (non-resizeable) array
behaviour.

# Examples
```jldoctest
julia> using ZMQ

julia> m = Message("foo");

julia> Char(m[1])            # Array indexing
'f': ASCII/Unicode U+0066 (category Ll: Letter, lowercase)

julia> m[end] = Int('g');    # Array assignment

julia> unsafe_string(m)      # Conversion to string (only do this if you know the message is a string)
"fog"

julia> IOBuffer(m)           # Create a zero-copy IOBuffer
IOBuffer(data=UInt8[...], readable=true, writable=false, seekable=true, append=false, size=3, maxsize=Inf, ptr=1, mark=-1)
```
"""
mutable struct Message <: AbstractArray{UInt8, 1}
    # Matching the declaration in the header: char _[64];
    w_padding::_Message
    handle::Ptr{Cvoid} # index into gc_protect, if any

    @doc """
        Message()

    Create an empty message (for receive).
    """
    function Message()
        zmsg = new()
        setfield!(zmsg, :handle, C_NULL)
        rc = lib.zmq_msg_init(zmsg)
        if rc != 0
            throw(StateError(jl_zmq_error_str()))
        end
        finalizer(close, zmsg)
        return zmsg
    end

    @doc """
        Message(len::Integer)

    Create a message with a given buffer size (for send).
    """
    function Message(len::Integer)
        zmsg = new()
        setfield!(zmsg, :handle, C_NULL)
        rc = lib.zmq_msg_init_size(zmsg, len)
        if rc != 0
            throw(StateError(jl_zmq_error_str()))
        end
        finalizer(close, zmsg)
        return zmsg
    end

    @doc """
        Message(origin::Any, m::Ptr{T}, len::Integer) where {T}

    Low-level function to create a message (for send) with an existing
    data buffer, without making a copy.  The origin parameter should
    be the Julia object that is the origin of the data, so that
    we can hold a reference to it until ZMQ is done with the buffer.
    """
    function Message(origin::Any, m::Ptr{T}, len::Integer) where {T}
        zmsg = new()
        setfield!(zmsg, :handle, gc_protect_handle(origin))
        gc_free_fn_c = @cfunction(gc_free_fn, Cint, (Ptr{Cvoid}, Ptr{Cvoid}))
        rc = lib.zmq_msg_init_data(zmsg, m, len, gc_free_fn_c, getfield(zmsg, :handle))
        if rc != 0
            gc_free_fn(C_NULL, getfield(zmsg, :handle)) # don't leak memory on error
            throw(StateError(jl_zmq_error_str()))
        end
        finalizer(close, zmsg)
        return zmsg
    end

    @doc """
        Message(m::String)

    Create a message with a string as a buffer (for send). Note: the Message now
    "owns" the string, it must not be resized, or even written to after the message
    is sent.
    """
    Message(m::String) = Message(m, pointer(m), sizeof(m))

    @doc """
        Message(p::SubString{String})

    Create a message with a sub-string as a buffer (for send). Note: the same
    ownership semantics as for [`Message(m::String)`](@ref) apply.
    """
    Message(p::SubString{String}) =
        Message(p, pointer(p.string)+p.offset, sizeof(p))

    @doc """
        Message(a::T) where T <: DenseVector

    Create a message with an array as a buffer (for send). Note: the same
    ownership semantics as for [`Message(m::String)`](@ref) apply.

    Usually `a` will be a 1D `Array`/`Vector`, but on Julia 1.11+ it can also be
    a `Memory`.
    """
    Message(a::T) where T <: DenseVector = Message(a, pointer(a), sizeof(a))

    @doc """
        Message(io::IOBuffer)

    Create a message with an
    [`IOBuffer`](https://docs.julialang.org/en/v1/base/io-network/#Base.IOBuffer) as
    a buffer (for send). Note: the same ownership semantics as for
    [`Message(m::String)`](@ref) apply.
    """
    function Message(io::IOBuffer)
        if !io.readable || !io.seekable
            error("byte read failed")
        end
        Message(io.data)
    end
end

"""
    isfreed(m::Message)

Check whether zeromq has called our free-function, i.e. whether we are safe to
reclaim ownership of any buffer object the [`Message`](@ref) was created with.
"""
isfreed(m::Message) = !haskey(gc_protect, getfield(m, :handle))

# AbstractArray behaviors:
Base.similar(a::Message, ::Type{T}, dims::Dims) where {T} = Array{T}(undef, dims) # ?
Base.length(zmsg::Message) = Int(lib.zmq_msg_size(zmsg))
Base.size(zmsg::Message) = (length(zmsg),)
Base.unsafe_convert(::Type{Ptr{UInt8}}, zmsg::Message) = Ptr{UInt8}(lib.zmq_msg_data(zmsg))
function Base.getindex(a::Message, i::Integer)
    @boundscheck if i < 1 || i > length(a)
        throw(BoundsError())
    end
    @preserve a unsafe_load(pointer(a), i)
end
function Base.setindex!(a::Message, v, i::Integer)
    @boundscheck if i < 1 || i > length(a)
        throw(BoundsError())
    end
    @preserve a unsafe_store!(pointer(a), v, i)
    return v
end

# Convert message to string (copies data)
Base.unsafe_string(zmsg::Message) = @preserve zmsg unsafe_string(pointer(zmsg), length(zmsg))

Base.elsize(::Message) = 1
Base.strides(::Message) = (1,)

# Build an IOStream from a message
# Copies the data
function Base.convert(::Type{IOStream}, zmsg::Message)
    Base.depwarn("convert(IOStream, ::Message) is deprecated, use `IOBuffer(zmsg)` instead to make a zero-copy IOBuffer from a Message.", :convert)
    s = IOBuffer()
    write(s, zmsg)
    return s
end

# Close a message. You should not need to call this manually (let the
# finalizer do it).
function Base.close(zmsg::Message)
    rc = lib.zmq_msg_close(zmsg)
    if rc != 0
        throw(StateError(jl_zmq_error_str()))
    end
    return nothing
end

function _get(zmsg::Message, property::Integer)
    val = lib.zmq_msg_get(zmsg, property)
    if val < 0
        throw(StateError(jl_zmq_error_str()))
    end
    val
end
function _set(zmsg::Message, property::Integer, value::Integer)
    rc = lib.zmq_msg_set(zmsg, property, value)
    if rc < 0
        throw(StateError(jl_zmq_error_str()))
    end
end
Base.propertynames(zmsg::Message) = (:more,)
function Base.getproperty(zmsg::Message, name::Symbol)
    if name === :more
        return _get(zmsg, MORE)
    else
        error("Message has no field $name")
    end
end
function Base.setproperty!(zmsg::Message, name::Symbol, value::Integer)
    # Currently the zmq_msg_set() function does not support any property names
    error("Message has no writable field $name")
end
function Base.get(zmsg::Message, option::Integer)
    Base.depwarn("get(zmsg, option) is deprecated; use zmsg.option instead", :get)
    return _get(zmsg, option)
end
@deprecate set(zmsg::Message, property::Integer, value::Integer) _set(zmsg, property, value)

# A server will report most errors to the client over a Socket, but
# errors in ZMQ state can't be reported because the socket may be
# corrupted. Therefore, we need an exception type for errors that
# should be reported locally.
struct StateError <: Exception
    msg::AbstractString
end

"""
Exception thrown by the `recv*()` methods if `rcvtimeo` is set and a receive
times out. The timeout itself can be obtained from the `timeout_secs` property
of the exception.
"""
struct TimeoutError <: Exception
    socket_info::String
    timeout_secs::Float64
end

Base.show(io::IO, thiserr::StateError) = print(io, "ZMQ: ", thiserr.msg)

function Base.show(io::IO, thiserr::TimeoutError)
    timeout_str = @sprintf("%.2fs", thiserr.timeout_secs)
    print(io, TimeoutError, ": $(thiserr.socket_info) receive timed out after $(timeout_str)")
end

# Basic functions

function jl_zmq_error_str()
    errno = lib.zmq_errno()
    c_strerror = lib.zmq_strerror(errno)

    if c_strerror != C_NULL
        strerror = unsafe_string(c_strerror)
        return strerror
    else
        return "Unknown error"
    end
end

# Socket options

for (fset, fget, k, T) in [
    (:set_affinity,                :get_affinity,                 4, UInt64)
    (:set_type,                    :get_type,                    16,   Cint)
    (:set_linger,                  :get_linger,                  17,   Cint)
    (:set_reconnect_ivl,           :get_reconnect_ivl,           18,   Cint)
    (:set_backlog,                 :get_backlog,                 19,   Cint)
    (:set_reconnect_ivl_max,       :get_reconnect_ivl_max,       21,   Cint)
    (:set_rate,                    :get_rate,                     8,   Cint)
    (:set_recovery_ivl,            :get_recovery_ivl,             9,   Cint)
    (:set_sndbuf,                  :get_sndbuf,                  11,   Cint)
    (:set_rcvbuf,                  :get_rcvbuf,                  12,   Cint)
    (nothing,                      :_zmq_getsockopt_rcvmore,     13,   Cint)
    (nothing,                      :get_events,                  15,   Cint)
    (:set_maxmsgsize,              :get_maxmsgsize,              22,   Cint)
    (:set_sndhwm,                  :get_sndhwm,                  23,   Cint)
    (:set_rcvhwm,                  :get_rcvhwm,                  24,   Cint)
    (:set_multicast_hops,          :get_multicast_hops,          25,   Cint)
    (:set_ipv4only,                :get_ipv4only,                31,   Cint)
    (:set_tcp_keepalive,           :get_tcp_keepalive,           34,   Cint)
    (:set_tcp_keepalive_idle,      :get_tcp_keepalive_idle,      35,   Cint)
    (:set_tcp_keepalive_cnt,       :get_tcp_keepalive_cnt,       36,   Cint)
    (:set_tcp_keepalive_intvl,     :get_tcp_keepalive_intvl,     37,   Cint)
    (:set_rcvtimeo,                :get_rcvtimeo,                27,   Cint)
    (:set_sndtimeo,                :get_sndtimeo,                28,   Cint)
    (:set_immediate,               :get_immediate,               39,   Cint)
    (:set_conflate,                :get_conflate,                54,   Cint)
    (nothing,                      :get_fd,                      14, Sys.iswindows() ? Ptr{Cvoid} : Cint)
    ]
    if fset != nothing
        @eval function $(Symbol("_",fset))(socket::Socket, option_val::Integer)
            rc = lib.zmq_setsockopt(socket, $k, Ref{$T}(option_val), sizeof($T))
            if rc != 0
                throw(StateError(jl_zmq_error_str()))
            end
        end
        prop = QuoteNode(Symbol(String(fset)[5:end]))
        @eval @deprecate $fset(socket::Socket, option_val::Integer) setproperty!(socket, $prop, option_val)
    end
    if fget != nothing
        @eval function $(Symbol("_",fget))(socket::Socket)
            val = Ref{$T}()
            rc = lib.zmq_getsockopt(socket, $k, val, Ref(Csize_t(sizeof($T))))
            if rc != 0
                throw(StateError(jl_zmq_error_str()))
            end
            return Int(val[])
        end
        prop = QuoteNode(Symbol(String(fget)[5:end]))
        @eval @deprecate $fget(socket::Socket) getproperty(socket, $prop)
    end
end

# For some functions, the publicly-visible versions should require &
# return boolean:
_get_rcvmore(socket::Socket) = Bool(__zmq_getsockopt_rcvmore(socket))
@deprecate get_rcvmore(socket::Socket) getproperty(socket, :rcvmore)
@deprecate ismore(socket::Socket) getproperty(socket, :rcvmore)

# subscribe/unsubscribe options take an arbitrary byte array
for (f,k) in ((:subscribe,6), (:unsubscribe,7))
    f_ = Symbol(f, "_")
    @eval begin
        function $f_(socket::Socket, filter::Ptr{T}, len::Integer) where {T}
            rc = lib.zmq_setsockopt(socket, $k, filter, len)
            if rc != 0
                throw(StateError(jl_zmq_error_str()))
            end
        end
        $f(socket::Socket, filter::Union{Vector{UInt8},String}) =
            @preserve filter $f_(socket, pointer(filter), sizeof(filter))
        $f(socket::Socket, filter::AbstractString) = $f(socket, String(filter))
        $f(socket::Socket) = $f_(socket, C_NULL, 0)
    end
end

# string properties
for (fset, fget, k) in [
    (:_set_routing_id,           :_get_routing_id,              5)
    (nothing,                    :_get_last_endpoint,          32)
    # (:_set_tcp_accept_filter,       nothing,                     38) #  deprecated
    ]
    if fset != nothing
        @eval function ($fset)(socket::Socket, option_val::String)
            if sizeof(option_val) > 255
                throw(StateError("option value too large"))
            end

            GC.@preserve option_val begin
                string_ptr = Base.unsafe_convert(Ptr{UInt8}, option_val)
                rc = lib.zmq_setsockopt(socket, $k, string_ptr, sizeof(option_val))
            end
            if rc != 0
                throw(StateError(jl_zmq_error_str()))
            end
        end
        @eval ($fset)(socket::Socket, option_val::AbstractString) = $fset(socket, String(option_val))
    end
    if fget != nothing
        @eval function ($fget)(socket::Socket)
            buf = Base.StringVector(255)
            len = Ref{Csize_t}(sizeof(buf))
            rc = lib.zmq_getsockopt(socket, $k, buf, len)
            if rc != 0
                throw(StateError(jl_zmq_error_str()))
            end
            return String(resize!(buf, len[]))
        end
    end
end
@deprecate get_identity(socket::Socket) getproperty(socket, :routing_id)
@deprecate set_identity(socket::Socket, val) setproperty!(socket, :routing_id, val)

# getproperty/setproperty API for socket properties
const sockprops = (:affinity, :type, :linger, :reconnect_ivl, :backlog, :reconnect_ivl_max,
                   :rate, :recovery_ivl, :sndbuf, :rcvbuf, :rcvmore, :events, :maxmsgsize,
                   :sndhwm, :rcvhwm, :multicast_hops, :ipv4only,
                   :tcp_keepalive, :tcp_keepalive_idle, :tcp_keepalive_cnt, :tcp_keepalive_intvl,
                   :rcvtimeo, :sndtimeo, :fd, :routing_id, :last_endpoint, :immediate, :conflate)

Base.propertynames(::Socket) = sockprops
@eval function Base.getproperty(value::Socket, name::Symbol)
    $(propexpression(filter!(p -> isdefined(@__MODULE__, Symbol("_get_", p)), collect(sockprops))) do p
        :($(Symbol("_get_", p))(value))
    end)
end
@eval function Base.setproperty!(value::Socket, name::Symbol, x)
    $(propexpression(filter!(p -> isdefined(@__MODULE__, Symbol("_set_", p)), collect(sockprops))) do p
        :($(Symbol("_set_", p))(value, x))
    end)
    return x
end

import Aqua
using ZMQ, Test

@info("Testing with ZMQ version $(ZMQ.version)")

@testset "ZMQ contexts" begin
    ctx=Context()
    @test ctx isa Context
    @test propertynames(ctx) isa Tuple

    @test_logs (:warn, r"set(.+) is deprecated") ZMQ.set(ctx, ZMQ.IO_THREADS, 3)
    @test (@test_logs (:warn, r"get(.+) is deprecated") get(ctx, ZMQ.IO_THREADS)) == 3

    @test (ctx.io_threads = 2) == 2
    @test ctx.io_threads == 2
    ZMQ.close(ctx)

    @test_throws StateError ctx.io_threads = 1
    @test_throws StateError ctx.io_threads

    #try to create socket with expired context
    @test_throws StateError Socket(ctx, PUB)

    # Smoke tests for Base.show()
    ctx = Context()
    @test repr(ctx) == "Context(WeakRef[])"
    close(ctx)
    @test repr(ctx) == "Context() (closed)"
end

# This test is in its own function to keep it simple and try to trick Julia into
# thinking it can safely GC the Context.
function context_gc_test()
    ctx = Context()
    s = Socket(ctx, PUB)

    # Force garbage collection to attempt to delete ctx
    GC.gc()

    # But it shouldn't be garbage collected since the socket should have a
    # reference to it, so the socket should still be open.
    @test isopen(s)
end

@testset "ZMQ sockets" begin
    context_gc_test()

    s=Socket(PUB)
    @test s isa Socket
    ZMQ.close(s)

    s1=Socket(REP)
    s1.sndhwm = 1000
    s1.linger = 1
    s1.routing_id = "abcd"

    @test s1.routing_id == "abcd"
    @test s1.sndhwm === 1000
    @test s1.linger === 1
    @test s1.rcvmore === false

    s2=Socket(REQ)
    @test s1.type == REP
    @test s2.type == REQ

    ZMQ.bind(s1, "tcp://*:5555")
    ZMQ.connect(s2, "tcp://localhost:5555")

    msg = Message("test request")

    # Smoke tests
    @test Base.elsize(msg) == 1
    @test Base.strides(msg) == (1,)

    # Test similar() and copy() fixes in https://github.com/JuliaInterop/ZMQ.jl/pull/165
    @test similar(msg, UInt8, 12) isa Vector{UInt8}
    @test copy(msg) == codeunits("test request")

    ZMQ.send(s2, Message("test request"))
    @test unsafe_string(ZMQ.recv(s1)) == "test request"
    ZMQ.send(s1, Message("test response"))
    @test unsafe_string(ZMQ.recv(s2)) == "test response"

    ZMQ.send(s2, "test request 2")
    @test ZMQ.recv(s1, String) == "test request 2"
    ZMQ.send(s1, Vector(codeunits("test response 2")))
    @test String(ZMQ.recv(s2, Vector{UInt8})) == "test response 2"
    ZMQ.send(s2, 3.14159)
    @test ZMQ.recv(s1, Float64) === 3.14159
    ZMQ.send(s1, [314159, 12345])
    @test ZMQ.recv(s2, Vector{Int}) == [314159, 12345]

    # Test task-blocking behavior
    global msg_sent = false
    t = @async begin
        global msg_sent
        sleep(0.5)
        msg_sent = true
        ZMQ.send(s2, Message("test request"))
        @test (unsafe_string(ZMQ.recv(s2)) == "test response")
    end

    # This will hang forver if ZMQ blocks the entire process since
    # we'll never switch to the other task
    @test unsafe_string(ZMQ.recv(s1)) == "test request"
    @test msg_sent == true
    ZMQ.send(s1, Message("test response"))
    wait(t)

    # Test _Message task-blocking behavior, similar to above
    c = Base.Condition()
    msg_sent = false
    @async begin
        global msg_sent
        sleep(0.5)
        msg_sent = true
        ZMQ.send(s2, "another test request")
        @test ZMQ.recv(s2, String) == "another test response"
        notify(c)
    end
    @test ZMQ.recv(s1, String) == "another test request"
    @test msg_sent == true
    ZMQ.send(s1, "another test response")
    wait(c)

    @testset "Receive timeouts" begin
        # Set s1's receive timeout to 0.5s, and check that it throws when there are
        # no incoming messages.
        s1.rcvtimeo = 500
        recv_timeout_elapsed = @elapsed @test_throws ZMQ.TimeoutError ZMQ.recv(s1)
        @test recv_timeout_elapsed >= s1.rcvtimeo / 1000

        # Test that the receive timeout functionality yields and doesn't block
        msg_sent = false
        # Set the receive timeout to something large
        s1.rcvtimeo = 10_000
        t = @async begin
            global msg_sent
            sleep(0.5)
            msg_sent = true
            ZMQ.send(s2, "foo request")
            @test ZMQ.recv(s2, String) == "bar response"
        end

        @test ZMQ.recv(s1, String) == "foo request"
        @test msg_sent == true
        ZMQ.send(s1, "bar response")
        wait(t)
        # Reset the timeout for the rest of the tests
        s1.rcvtimeo = -1
    end

    ZMQ.send(s2, Message("another test request"))
    msg = ZMQ.recv(s1)
    o = IOBuffer(msg)
    @test String(take!(o)) == "another test request"
    ZMQ.send(s1) do io
        print(io, "buffer ")
        print(io, "this")
    end
    @test String(take!(ZMQ.recv(s2, IOBuffer))) == "buffer this"

    @testset "Message AbstractVector interface" begin
        m = Message("1")
        @test m[1]==0x31
        @test (m[1]=0x32) === 0x32
        @test unsafe_string(m)=="2"
        finalize(m)
    end

    # Test multipart messages
    data = ["foo", "bar", "baz"]
    ZMQ.send_multipart(s2, data)

    # Test receiving Message's
    msgs = ZMQ.recv_multipart(s1)
    @test msgs isa Vector{Message}
    @test String.(msgs) == data

    # Test receiving a specific type
    data = Int[1, 2, 3]
    ZMQ.send_multipart(s1, data)
    msgs = ZMQ.recv_multipart(s2, Int)
    @test msgs isa Vector{Int}
    @test msgs == data

    # ZMQ.close(s1); ZMQ.close(s2) # should happen when context is closed
    ZMQ.close(ZMQ._context) # immediately close global context rather than waiting for exit
    @test !isopen(s1)
    @test !isopen(s2)

    # Smoke tests for Base.show() in different Socket situations
    s1 = Socket(REP)
    @test repr(s1) == "Socket(REP)"
    ZMQ.bind(s1, "tcp://127.0.0.1:5555")
    @test repr(s1) == "Socket(REP, tcp://127.0.0.1:5555)"
    close(s1)
    @test repr(s1) == "Socket() (closed)"
end

@testset "Message" begin
    # Test all the send constructors
    s1 = Socket(PUB)
    s2 = Socket(SUB)
    ZMQ.subscribe(s2, "")
    ZMQ.bind(s1, "tcp://*:5555")
    ZMQ.connect(s2, "tcp://localhost:5555")

    # Sleep for a bit to prevent the 'slow joiner' problem
    sleep(0.5)

    # Message(::Int) - construct from buffer size
    data = rand(UInt8, 10)
    m1 = Message(length(data))
    # Note that we don't use copy!() for compatibility with Julia 1.3
    for i in eachindex(data)
        m1[i] = data[i]
    end
    ZMQ.send(s1, m1)
    @test ZMQ.recv(s2) == data

    # Message(::Any, ::Ptr, ::Int) - construct from pointer to existing data
    buffer = rand(UInt8, 10)
    m2 = Message(buffer, pointer(buffer), length(buffer))
    ZMQ.send(s1, m2)
    @test ZMQ.recv(s2) == buffer

    # Message(::String)
    str_msg = "foobar"
    m3 = Message(str_msg)
    ZMQ.send(s1, m3)
    @test String(ZMQ.recv(s2)) == str_msg

    # Message(::SubString)
    m4 = Message(SubString(str_msg, 1:3))
    ZMQ.send(s1, m4)
    @test String(ZMQ.recv(s2)) == str_msg[1:3]

    # Message(::DenseVector) - construct from array
    buffer2 = rand(UInt8, 10)
    m5 = Message(buffer2)
    ZMQ.send(s1, m5)
    @test ZMQ.recv(s2) == buffer2

    # Message(::IOBuffer)
    buffer3 = rand(UInt8, 10)
    iobuf = IOBuffer(buffer3)
    m6 = Message(iobuf)
    ZMQ.send(s1, m6)
    @test ZMQ.recv(s2) == buffer3

    close(iobuf)
    @test_throws ErrorException Message(iobuf)

    close(s1)
    close(s2)

    # Test indexing
    m = Message(10)
    @test_throws BoundsError m[0]
    @test_throws BoundsError m[11]
    @test_throws BoundsError m[0] = 1
    @test_throws BoundsError m[11] = 1

    @test propertynames(m) isa Tuple
    @test_logs (:warn, r"set(.+) is deprecated") (@test_throws StateError ZMQ.set(m, ZMQ.MORE, 1))
    @test (@test_logs (:warn, r"get(.+) is deprecated") get(m, ZMQ.MORE)) == 0
    @test_throws ErrorException m.foo
    @test_throws ErrorException m.more = 1

    # Smoke tests
    @test !Bool(m.more)
    @test_throws ErrorException m.more = true
    @test ZMQ.isfreed(m)
    @test_logs (:warn, r"convert(.+) is deprecated") convert(IOStream, m)
end

@testset "ZMQ resource management" begin
    local leaked_req_socket, leaked_rep_socket
    ZMQ.Socket(ZMQ.REQ) do req_socket
        leaked_req_socket = req_socket

        ZMQ.Socket(ZMQ.REP) do rep_socket
            leaked_rep_socket = rep_socket

            ZMQ.bind(rep_socket, "inproc://tester")
            ZMQ.connect(req_socket, "inproc://tester")

            ZMQ.send(req_socket, "Mr. Watson, come here, I want to see you.")
            @test unsafe_string(ZMQ.recv(rep_socket)) == "Mr. Watson, come here, I want to see you."
            ZMQ.send(rep_socket, "Coming, Mr. Bell.")
            @test unsafe_string(ZMQ.recv(req_socket)) == "Coming, Mr. Bell."
        end

        @test !ZMQ.isopen(leaked_rep_socket)
    end
    @test !ZMQ.isopen(leaked_req_socket)

    local leaked_ctx
    ZMQ.Context() do ctx
        leaked_ctx = ctx

        @test isopen(ctx)
    end
    @test !isopen(leaked_ctx)
end

@testset "Utilities" begin
    @test ZMQ.lib_version() isa VersionNumber
    @test repr(ZMQ.StateError("foo")) == "ZMQ: foo"
    @test repr(ZMQ.TimeoutError("Foo", 1.2)) == "ZMQ.TimeoutError: Foo receive timed out after 1.20s"
end

@testset "Aqua.jl" begin
    Aqua.test_all(ZMQ)
end

# Bindings

This page documents the low-level bindings to libzmq that were automatically
generated. Where possible, the docstrings link to the [upstream
documentation](https://libzmq.readthedocs.io). Bindings have not been generated
for deprecated functions.

!!! danger
    These bindings are unsafe, do not use them unless you know what you're doing.

---

```@autodocs
Modules = [ZMQ.lib]
```

```@meta
CurrentModule = ZMQ
```

# Changelog

This documents notable changes in ZMQ.jl. The format is based on [Keep a
Changelog](https://keepachangelog.com).

## [v1.5.1] - 2025-11-04

### Fixed
- Refactored some internal methods to reduce invalidations ([#263]).

## [v1.5.0] - 2025-09-13

### Added
- Added support for the `rcvtimeo` property, now [`recv(::Socket)`](@ref) and
  the other receive methods will throw a [`TimeoutError`](@ref) if the receive
  times out ([#217]).

## [v1.4.1] - 2025-06-13

### Changed
- Implemented `Base.show()` methods for [`Socket`](@ref) and [`Context`](@ref)
  for pretty-printing ([#255]).

### Fixed
- The precompilation workload now hardcodes the use of IP address `127.0.0.1`
  instead of resolving `localhost`, which fixes precompilation on machines that
  may have `localhost` resolve to a different node ([#257]).

## [v1.4.0] - 2024-11-30

### Added
- Implemented [`send_multipart()`](@ref) and [`recv_multipart()`](@ref) for
  working with multipart messages ([#253]).

## [v1.3.0] - 2024-08-03

### Added
- Support for creating [`Message`](@ref)'s from the new `Memory` type in Julia
  1.11 ([#244]).
- Full [Bindings](@ref) to libzmq ([#232]).

### Deprecated
- The `Base.convert(IOStream, ::Message)` method has been deprecated due to
  buggy behaviour, use `IOBuffer(msg)` instead ([#247]).

### Fixed
- Fixed [`isfreed()`](@ref), which would previously return the wrong values
  ([#245]).

## [v1.2.6] - 2024-06-13

### Added

- [`lib_version()`](@ref) to get the libzmq version ([#240]).

### Fixed

- Fixed a precompilation bug that would cause creating a sysimage with
  PackageCompiler.jl on Julia 1.6 to fail ([#242]).

## [v1.2.5] - 2024-05-28

### Fixed

- Fixed support for Julia 1.3 in the precompilation workload ([#237]).

## [v1.2.4] - 2024-05-27

### Changed

- Refactored the internals to use the public `FileWatching.FDWatcher` instead of
  `FileWatching._FDWatcher` ([#215]).

### Fixed

- Docstrings to inner constructors are now assigned properly ([#227]).
- [`Socket`](@ref) now holds a reference to its [`Context`](@ref) to prevent it from
  being garbage collected accidentally ([#229]).
- Changed the precompilation workload to use any available port to avoid port
  conflicts ([#234]).

## [v1.2.3] - 2024-05-12

### Added

- Support for setting `ZMQ_IMMEDIATE` and `ZMQ_CONFLATE` on sockets ([#209],
  [#222]).
- Overloads for [`Message`](@ref) to allow deserializing them with MsgPack.jl
  ([#214]).
- A precompilation workload to improve TTFX ([#224]).

```@meta
CurrentModule = ZMQ
```

# Reference

```@docs
lib_version
TimeoutError
```

## Sockets

The ZMQ Socket type:

```@docs
Socket
Socket(::Context, ::Integer)
Socket(::Integer)
Socket(::Function)
isopen
close
```

[`Socket`](@ref) implements the
[`Sockets`](https://docs.julialang.org/en/v1/stdlib/Sockets/) interface:
```@docs
bind
connect
recv
recv_multipart
send
send_multipart
```

ZMQ socket types (note: some of these are aliases; e.g. `XREQ = DEALER`):
```@docs
PAIR
PUB
SUB
REQ
REP
DEALER
ROUTER
PULL
PUSH
XPUB
XSUB
XREQ
XREP
UPSTREAM
DOWNSTREAM
```

## Messages

```@docs
Message
Message()
Message(::Integer)
Message(::Any)
Message(::String)
Message(::SubString{String})
Message(::DenseVector)
Message(::IOBuffer)
isfreed(::Message)
```

## Context

```@docs
ZMQ.context
```

# Guide

## Usage

```julia
using ZMQ

s1=Socket(REP)
s2=Socket(REQ)

bind(s1, "tcp://*:5555")
connect(s2, "tcp://localhost:5555")

send(s2, "test request")
msg = recv(s1, String)
send(s1, "test response")
close(s1)
close(s2)
```

The `send(socket, x)` and `recv(socket, SomeType)` functions make an extra copy of the data when converting
between ZMQ and Julia.   Alternatively, for large data sets (e.g. very large arrays or long strings), it can
be preferable to share data, with `send(socket, Message(x))` and `msg = recv(socket, Message)`, where the `msg::Message`
object acts like an array of bytes; this involves some overhead so it may not be optimal for short messages.

(Help in writing more detailed documentation would be welcome!)

# ZMQ.jl

*A Julia interface to ZeroMQ.*

**ZMQ.jl** is a [Julia](http://julialang.org) interface to [ZeroMQ, The Intelligent Transport Layer](http://zeromq.org).

## Package Features

- Access ZeroMQ sockets from Julia

The [Guide](@ref) provides a tutorial explaining how to get started using ZMQ.jl.

Some examples are linked on the [Examples](@ref) page.

See the [Reference](@ref) for the complete list of wrapped functions and types.

# Examples

Examples using **ZMQ.jl** can be found in the [ZeroMQ Guide (zguide)](https://zguide.zeromq.org/) or directly in [its repository](https://github.com/booksbyus/zguide/tree/master/examples/Julia)
